package dev.pfaff.altargui;

/**
 * Responsible for maintaining widget state.
 */
public interface StateContext {
    /**
     * Gets or instantiates a new element and configures it according to the provided widget.
     * <p>
     * <strong>Note</strong>: elements are keyed by the parent key, the {@code key}, and the widget class.
     */
    <W extends Widget> WidgetInstance<W> getState(WidgetInstance<?> parent, Key.CallSite key, W widget);

    default <W extends Widget> WidgetInstance<W> getStateIndexed(WidgetInstance<?> parent, int index, W widget) {
        return getState(parent, new Key.IntValue(index), widget);
    }
}
